Redmine - Feature #31225

Show the number of days left until the due date in reminders
2019-04-19 08:51 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Email notifications Estimated time: 0.00 hour
Target version: 4.1.0

Resolution: Fixed

Description

It is useful if we can know the due date of each issue in reminder. | think that adding information "Due in X days" or "X days late" for

each issue is nice.
[Before]
* eCookbook - Bug #1: Cannot print recipes

* OnlineStore - Bug #4: Issue on project 2
* eCookbook - Feature request #2: Add ingredients categories

[After]

* eCookbook - Bug #1: Cannot print recipes (Due in 3 days)

* OnlineStore - Bug #4: Issue on project 2 (Due in 1 days)

* eCookbook - Feature request #2: Add ingredients categories (3 days late)

Related issues:

Related to Redmine - Patch #6357: Show and sort by due_date in reminders Closed 2010-09-10
Related to Redmine - Feature #23778: default sort email reminders by due date... Closed

Associated revisions

Revision 18174 - 2019-05-19 10:52 - Go MAEDA

Show the number of days left until the due date in reminders (#31225).

Patch by Yuichi HARADA.

Revision 18190 - 2019-05-22 17:18 - Go MAEDA
MailerTest fails depending on the time (#31225).

Patch by Go MAEDA.

History

#1 - 2019-04-19 08:57 - Go MAEDA

I noticed a few weeks ago that reminders from Planio already has the information. It is really useful.

#2 - 2019-04-29 04:44 - Go MAEDA
- Related to Patch #6357: Show and sort by due_date in reminders added

#3 - 2019-04-29 04:44 - Go MAEDA

- Related to Feature #23778: default sort email reminders by due date (and list due date in email) added

#4 - 2019-05-17 04:30 - Yuichi HARADA
- File 31225_show_days_until_due_date.patch added

+1
| think it is useful because | can understand the number of days until the due date.
| attached a patch.

#5 - 2019-05-17 18:32 - Go MAEDA

- Target version set to Candidate for next major release

#6 - 2019-05-18 00:29 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

| applied this patch to my production environment and found that the information "Due in X days" / "X days late" is useful. It made me realize that
there were too many overdue issues!

| am setting the target version to 4.1.0.

#7 - 2019-05-19 10:53 - Go MAEDA

- Subject changed from Show how many days are left until the due date in reminders to Show the number of days left until the due date in reminders
- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thanks.

#8 - 2019-05-20 01:36 - Go MAEDA
- Status changed from Closed to Reopened
The tests fail depending on the timezone.

| think the error occurs when the date of the current timezone is different from the date in UTC. For example, | observed the following error on 20 May
2019 08:15:00 +0900 (19 May 2019 23:15:00 UTC)

F

Failure:
MailerTest#test_reminders_should_sort_issues_by_due_date [/Users/maeda/redmines/trunk/test/unit/mailer_test.rb
:749]:

<(?-mix:foo \ (1 day late\))> expected but was
<eCookbook - Bug #219: foo (2 days late)>..
Expected 0 to be >= 1.

bin/rails test test/unit/mailer_test.rb:738
#9 - 2019-05-20 07:23 - Yuichi HARADA

- File 31225_fix_test.patch added

Go MAEDA wrote:

The tests fail depending on the timezone.

I think the error occurs when the date of the current timezone is different from the date in UTC. For example, | observed the following error on 20
May 2019 08:15:00 +0900 (19 May 2019 23:15:00 UTC)

[..]

Sorry, | fixed to the UTC Date at 0:00 using travel_to Date.today.to_time(:utc) .
This fix eliminates the dependency on time zones.

#10 - 2019-05-20 17:26 - Go MAEDA
Yuichi HARADA wrote:
Sorry, | fixed to the UTC Date at 0:00 using travel_to Date.today.to_time(:utc) .

This fix eliminates the dependency on time zones.

Unfortunately, tests still fail.
$ date

Tue May 21 00:22:38 JST 2019

$ bin/rails test test/unit/mailer_test.rb:622
Run options: --seed 55322

# Running:

Ej

Failure:

MailerTest#test_reminders [/Users/maeda/redmines/trunk/test/unit/mailer_test.rb:628]:

"Bug #3: Error 281 when updating a recipe (5 days late)" not found in "1 issue(s) that are assigned to you are

due in the next 42 days::
* eCookbook - Bug #3: Error 281 when updating a recipe (6 days late)

View all issues (2 open)
http://localhost:3000/issues?assigned_to_id=me&set_filter=1&sort=due_date%$3Aasc

You have received this notification because you have either subscribed to it, or are involved in it.

To change your notification preferences, please click here: http://hostname/my/account
n

bin/rails test test/unit/mailer_test.rb:622

Finished in 1.727797s, 0.5788 runs/s, 2.3151 assertions/s.
1 runs, 4 assertions, 1 failures, 0 errors, 0 skips

#11 - 2019-05-22 02:50 - Yuichi HARADA
- File 31225_fix_test _v2.patch added

When replacing Time with Date, due_date was incorrect because timezone and time were truncated.
| rebuilt a test.

#12 - 2019-05-22 07:31 - Go MAEDA

- File 24941_set time_zone_to_utc.patch added

Yuichi HARADA wrote:
When replacing Time with Date, due_date was incorrect because timezone and time were truncated.
| rebuilt a test.

Thank you for updating the test. | wrote a simpler patch.

The root cause of the test failure is that a time zone is not set for users in test fixtures. Because of that, the time zone of users while running test
depends on the timezone of the PC, and the result of test will be unstable.

This patch fixes the problem by fixing the user's time zone to UTC while running mailer_test.

#13 - 2019-05-22 17:23 - Go MAEDA
- Status changed from Reopened to Closed
Go MAEDA wrote:

The tests fail depending on the timezone.

I think the error occurs when the date of the current timezone is different from the date in UTC. For example, | observed the following error on 20
May 2019 08:15:00 +0900 (19 May 2019 23:15:00 UTC)

(-]

Committed the fix #31225#note-12 in r18190.

Files
31225_show_days_until_due_date.patch 3.92 KB 2019-05-17 Yuichi HARADA
31225 fix_test.patch 8.09 KB 2019-05-20 Yuichi HARADA
https://www.redmine.org/issues/31225#note-12
https://www.redmine.org/projects/redmine/repository/svn/revisions/18190

31225_fix_test_v2.patch 5.32 KB 2019-05-22 Yuichi HARADA
24941_set_time_zone_to_utc.patch 2.62 KB 2019-05-22 Go MAEDA
